/* Converts any binary file to ASCII - for each bit set to 1 writes '#' and for each 0 - ' '
Shortly, outputs binary representation of files.
100% pure ANSI C
written by GDR! <gdr@go2.pl>
			http://www.GDR.w.pl/
*/

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
  #ifdef __MSDOS__
   #include <conio.h>
  #endif

#define DEBUG

char* secstostr(int);
int main(int argc, char** argv)
{
  int ch,x;
  FILE* fin;
  FILE* fout;
  long a,cpl,max;
  int* last;
  time_t beg,cur;
  #ifdef __MSDOS__
   clrscr();
  #endif
  printf("Binary to ASCII - bit representation converter by GDR! http://www.GDR.w.pl/\n");
  if(argc!=4)
  {
   printf("Usage:\n%s infile outfile chars_per_line\n",argv[0]);
   exit(0);
   }
  cpl=atoi(argv[3]);
  fin=fopen(argv[1],"rb");
  if(!fin)
  {
   printf("Couldn't open input file:%s\n",argv[1]);
   exit(0);
   }
  fout=fopen(argv[2],"wb");
  if(!fout)
  {
   fclose(fin);
   printf("Couldn't write to output file:%s\n",argv[2]);
   exit(0);
   }
  fseek(fin,0,SEEK_END);
  max=ftell(fin);
  fseek(fin,0,SEEK_SET);
  last=malloc(sizeof(int)*cpl);
  fprintf(fout, "File:%s, Size:%d, bytes per line:%d (%d bits)\n:",argv[1],max,cpl,cpl*8);
  beg=clock();
  for(a=0;a<=max;a++)
  {
     if((a%cpl)==0)
     {
#ifdef DEBUG
      fprintf(fout,"| ");
      for(x=0;x<cpl;x++)
       {
        if(a) fprintf(fout,"%d ",last[x]);
       }
#endif
      fprintf(fout,"\n%X: ",a);
     }
     ch=fgetc(fin);
     last[a%cpl]=ch;
     if(ch&128) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&64) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&32) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&16) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&8) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&4) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&2) fputc('#',fout);
      else fputc(' ',fout);
     if(ch&1) fputc('#',fout);
      else fputc(' ',fout);
if(!(a%65536))
     {
          int elp,exp;
          time_t dif;
          cur=clock();
          dif=cur-beg;
          elp=dif/CLK_TCK;
          exp=((float)elp/((float)a/(float)max));
          #ifdef __MSDOS__
           gotoxy(1,4);
          #endif
        printf("%d of %d bytes done (%f %%).\nTime elapsed:%s, expected:%s, to go:%s                         \n",a,max,(((float)a/(float)max)*100),secstostr(elp),secstostr(exp),secstostr(exp-elp));
        }
     }
  fprintf(fout,"\nEnd of file %s.\nThis file has been produced by GDR!\'s Bin to ASCII - binary representation converter\nFor more useful programs look at http://www.GDR.w.pl/\n",argv[1]);
  fclose(fout);
  fclose(fin);
  free(last);
  return(0);
  }

char* secstostr(int s)
{
      int hr;
      int min;
      int sec;
      char* r=malloc(10);
      hr=s/3600;
      s-=hr*3600;
      min=s/60;
      s-=min*60;
      sec=s;
      sprintf(r,"%2d:%2d:%2d",hr,min,sec);
      return(r);
      }
